#!/bin/sh
#
# autorun.sh - setup ssh service to run on Transcend SDWifi card 
# 
# This script needs to be in the root directory of the SD card and is automatically 
# executed by the Transcend boot process. This script copies necessary binaries to 
# run a sshd (dropbear) only when the card is connected to a trusted network. The 
# users need to edit the access.sh file to enter the necessary info (see access.sh)
#
# Author:  Arul Selvan
# Version: May 2, 2014
# 
# CREDIT: this script is based on information and code shared from original authors below.
# https://www.pitt-pladdy.com/blog/_20140202-083815_0000_Transcend_Wi-Fi_SD_Hacks_CF_adaptor_telnet_custom_upload_/
# http://haxit.blogspot.ch/2013/08/hacking-transcend-wifi-sd-cards.html
# 
# DISCLAIMER: Use it at your own risk. I am not responsible for any loss or damage to your property.

sd_path="/mnt/sd/custom"

# telnet access to initially debug and setup everything.
# CAUTION: You must comment/remove the line below once dropbear is working as expected.
# /usr/bin/rcS6 &

# setup a busybox with more applets than the one comes with Transcend firmware
cp $sd_path/busybox-armv5l $sd_path/dropbearmulti-armv5l  /sbin/.
chmod a+x $sd_path/busybox-armv5l  $sd_path/dropbearmulti-armv5l

# setup dropbear
ln -s /sbin/dropbearmulti-armv5l /sbin/dropbear
ln -s /sbin/dropbearmulti-armv5l /sbin/dropbearkey
ln -s /sbin/dropbearmulti-armv5l /usr/bin/scp
ln -s /sbin/dropbearmulti-armv5l /usr/bin/ssh
mkdir /etc/dropbear
chmod 0700 /etc/dropbear
cp $sd_path/dropbear_rsa_host_key $sd_path/authorized_keys /etc/dropbear/.
chmod 0600 /etc/dropbear/authorized_keys
chmod a+r /etc/dropbear/dropbear_*
ln -s /etc/dropbear ~/.ssh
# dropbear needs /etc/passwd file at the minimum
echo "root:x:0:0:root:/:/bin/sh" >/etc/passwd
touch /var/log/lastlog
touch /var/log/wtmp

# add custom dhcp code (ntpd & local access)
cat $sd_path/ntpd.sh >>/etc/dhcp.script
cat $sd_path/access.sh >>/etc/dhcp.script

# safety - change mount to ro
busybox-armv5l sed -i.orig -e 's/ -w / /' -e 's/-o iocharset/-o ro,iocharset/' /usr/bin/refresh_sd
refresh_sd
