# 
# access.sh - starts ssh service once we get connected to our trusted wireless network
#
# Note: need to change the variable "trusted_network" to match your network.
#
# Author:  Arul Selvan
# Version: May 2, 2014
# 
# CREDIT: this script is based on information and code shared from original authors below.
# https://www.pitt-pladdy.com/blog/_20140202-083815_0000_Transcend_Wi-Fi_SD_Hacks_CF_adaptor_telnet_custom_upload_/
# http://haxit.blogspot.ch/2013/08/hacking-transcend-wifi-sd-cards.html
# 
# DISCLAIMER: Use it at your own risk. I am not responsible for any loss or damage to your property.

# TODO: modify the variable below to add your own ssid:ip:mac to trust 
log_file="/tmp/access.sh.log"

# kill dropbear
killaccessdaemons() {
    if [ -f /var/run/dropbear.pid ]; then
        kill `cat /var/run/dropbear.pid`
        rm /var/run/dropbear.pid
    fi
}

# start dropbear for sshd service
startaccessdaemons() {
    if [ ! -f /var/run/dropbear.pid ] || [ ! -d /proc/`cat /var/run/dropbear.pid` ]; then
        dropbear -s -r /etc/dropbear/dropbear_rsa_host_key
        echo "started dropbear, PID=`cat /var/run/dropbear.pid`" >> $log_file
	/usr/bin/tcpsvd -vE 0.0.0.0 21 /usr/sbin/ftpd /mnt/sd 2>&1 >> /tmp/log.ftpd &
    fi
}

# check the situation and act accordingly
case "$1" in
    deconfig)
        killaccessdaemons
    ;;
    bound)
        startaccessdaemons
    ;;
    renew)
        # do nothing - no change
    ;;
esac
